defmodule Beanstream.Card do
  @moduledoc """
  Credit card information.
  """

  defstruct [
    name: nil,          # card holder name (64 alpha)
    number: nil,        # card number (20 digits)
    expiry_month: nil,  # 01-12 (2 digits)
    expiry_year: nil,   # 16 for 2016 (2 digits)
    cvd: nil,           # optional (3-4 digits)
    complete: true,     # complete a payment (false to pre-authorize)
  ]

  @type t :: %Beanstream.Card{
    name: String.t,
    number: String.t,
    expiry_month: String.t,
    expiry_year: String.t,
    cvd: String.t,
    complete: boolean,
  }

end
